Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoLodManager.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoLodManager.cpp	(revision 1309)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoLodManager.cpp	(revision 1526)
@@ -12,81 +12,375 @@
 #include "GeoLodManager.h"
 #include "GeoLodObject.h"
-#include <algorithm>
-/*
+#include "VertexData.h"
+#include <ntls.h>
+#include <map>
+
+using namespace Geometry;
+
+//#define MINIMUM_VALID_LOD_SIMILARITY 0.1f
+
+
 namespace Geometry
 {
-
-
-	class lodobj_idpos_node_t
+	class lodobj_node_t : public Moveable<lodobj_node_t>
 	{
 	public:
-		lodobj_idpos_node_t(LodObject *o):lodobj(o),must_recalculate_distance(true),dist2cam(0.0f){}
+		lodobj_node_t(const std::string &nam, float dist, LodObject *o):dist2cam(dist),lodobj(o),name(nam){ must_recalculate_distance=false; to_update=0; master=NULL; lodfactor=o->GetCurrentLodFactor(); precalpos=-1; }
+		lodobj_node_t(const lodobj_node_t &n){ operator=(n); }
+		float dist2cam;
 		LodObject *lodobj;
-		float dist2cam; // used to index the lodobj in the other map
-		bool operator < (const lodobj_idpos_node_t &o) const { return (lodobj->GetUniqueID()<o.lodobj->GetUniqueID()); }
+		bool must_recalculate_distance;
+		uint32 to_update;
+		bool operator < (const lodobj_node_t &o) const { return (dist2cam < o.dist2cam); }
+		void operator = (const lodobj_node_t &n){ dist2cam=n.dist2cam; lodobj=n.lodobj; must_recalculate_distance=n.must_recalculate_distance; master=n.master; lodfactor=n.lodfactor; precalpos=-1; name=n.name; }
+
+		lodobj_node_t * master;
+		VectorMap<uint32,lodobj_node_t*> disciples;
+		float lodfactor; // virtual lod factor (the lodfactor it seems, not its real internal lodfactor)
+		int precalpos;
+		std::string name;
 	};
-}*/
-
-using namespace Geometry;
-
-LodManager::LodManager(float near, float far, const Geometry::Vector3 &campos)
-:targetFPS(30),camera_changed(true),camera_pos(campos),
- near_range(near),far_range(far)
-{
-	// make the lodobj_dists vector into a heap
-	make_heap(lodobj_dists.begin(),lodobj_dists.end());
-}
-
-void Geometry::LodManager::AddLodObj(LodObject * o, const Geometry::Vector3 &p)
-{
-	float dist = CalculateDistToCamera(p);
-	lodobj_dists.push_back(lodobj_dist_node_t(dist,o));
-	push_heap(lodobj_dists.begin(),lodobj_dists.end());
-//	lodobj_dists[dist] = lodobj_dist_node_t(o);
+
+	class NodeContainer
+	{
+	public:
+		Vector<lodobj_node_t> lodobj_dists;
+		std::map<uint32,Geometry::Vector3> lodobj_pos; // map key: LodObject UniqueID for efficient ID-based finding
+		Vector3 camera_pos;
+
+		int num_lod_sim;
+
+		NodeContainer(const Geometry::Vector3 &campos)
+			:camera_pos(campos){
+		}
+
+		~NodeContainer(void){
+			for (VectorMap<std::string,lodobj_node_t**>::Iterator it = precalculated_lods.Begin(); 
+																  it != precalculated_lods.End(); it ++)
+			{
+				lodobj_node_t **nodes = *it;
+				delete[] nodes;
+			}
+		}
+
+		void RecalculateDist(lodobj_node_t & node){
+			std::map<uint32,Vector3>::iterator posit = lodobj_pos.find(node.lodobj->GetUniqueID());
+			assert(posit!=lodobj_pos.end());
+			const Vector3 & pos = posit->second;
+
+			node.dist2cam = CalculateDistToCamera(pos);
+		}
+
+		float CalculateDistToCamera(const Geometry::Vector3 &p) const
+		{
+			Geometry::Vector3 v = camera_pos - p;
+			float distquad = v.length();
+			return distquad;
+		}
+
+		lodobj_node_t * & GetPrecalculatedLOD(const std::string &name, int ipos){
+			int foundpos = precalculated_lods.Find(name);
+			if (foundpos==-1)
+			{
+				lodobj_node_t **new_precalculated_lods=new lodobj_node_t*[num_lod_sim+1]; // +1 is done to include the highest lod (1.0)
+				for (int i=0; i<num_lod_sim+1; i++)
+					new_precalculated_lods[i]=NULL;
+				precalculated_lods.Add(name) = new_precalculated_lods;
+				return new_precalculated_lods[ipos];
+			}
+			else
+			{
+				return precalculated_lods[foundpos][ipos];
+			}
+		}
+
+		uint32 lod2precalpos(Real lodfactor){ 
+			return (uint32)(num_lod_sim*lodfactor); 
+		}
+
+	private:
+		// the following is an array of precalculated lods
+		// for 10 precalculated lods each element is in order [0.1, 0.2, 0.3, 0.4, 0.5, ...]
+		// for 100 precalculated lods each element is in order [0.01, 0.02, 0.03, 0.04, 0.05, ...]
+		// the funcion lod2precalpos translates a LOD factor to a position in the array
+		VectorMap<std::string,lodobj_node_t**> precalculated_lods;
+
+	};
+}
+
+LodManager::LodManager(Real near, Real far, const Geometry::Vector3 &campos, int numslots)
+:lasttime(0),camera_changed(true),node_added(false),
+ near_range(near),far_range(far),
+ always_calculate_lod(false),force_highest_lod(false)
+{
+	lodobj_container=new NodeContainer(campos);
+	lodobj_container->num_lod_sim = numslots;
+}
+
+LodManager::~LodManager(void)
+{
+	delete lodobj_container;
+//	delete[] precalculated_lods;
+}
+
+void Geometry::LodManager::AddLodObj(const std::string &name, LodObject * o, const Geometry::Vector3 &p)
+{
+	float dist = lodobj_container->CalculateDistToCamera(p);
+	lodobj_node_t auxnode(name,dist,o);
+	
+	lodobj_container->lodobj_dists.Add(auxnode);
+	Sort(lodobj_container->lodobj_dists);
+
 	UpdateLODObjectPos(o,p);
-}
-
-
-void Geometry::LodManager::UpdateLOD(void)
-{
-	if (!lodobj_dists.empty())
+	node_added=true;
+}
+
+
+void Geometry::LodManager::UpdateLOD(uint32 currFPS, uint32 targetFPS)
+{
+	if (!lodobj_container->lodobj_dists.IsEmpty())
 	{
 		// update distances to the camera
-		bool must_resort = false;
-		for (std::vector<lodobj_dist_node_t>::iterator it=lodobj_dists.begin(); it!=lodobj_dists.end(); it++)
-		{			
-			lodobj_dist_node_t & node = *it;
-			if (camera_changed || node.must_recalculate_distance)
-			{
-				RecalculateDist(node);
-				must_resort=true;
-			}
-		}
-		if (must_resort)
-			sort_heap(lodobj_dists.begin(),lodobj_dists.end());
-
-		// select a tree to change its LOD
-	//	float random_dist = SelectRandomDistance();
-	//	std::map<float,Geometry::lodobj_dist_node_t>::iterator nearest = lodobj_dists.upper_bound(random_dist);
-
-		// the begining of the list is the greater element (greater dist)		
-		lodobj_dist_node_t & node = lodobj_dists.front();
+		if (camera_changed || node_added)
+		{
+			bool must_resort = false;
+			for (Vector<lodobj_node_t>::Iterator it=lodobj_container->lodobj_dists.Begin(); 
+												 it!=lodobj_container->lodobj_dists.End(); 
+												 it++)
+			{			
+				lodobj_node_t & node = *it;
+				if (node.must_recalculate_distance || camera_changed || node_added)
+				{
+					lodobj_container->RecalculateDist(node);
+					must_resort=true;
+				}
+			}
+/*			if (must_resort)
+				Sort(lodobj_container->lodobj_dists);*/
+		}
+
+		// the end of the list is the greater element (greater dist)	
+/*		if (currFPS < targetFPS - 5)
+		{
+			Vector<lodobj_node_t>::Iterator selnode;
+			for (selnode=lodobj_container->lodobj_dists.End()-1; selnode!=lodobj_container->lodobj_dists.Begin()-1; selnode--)
+			{			
+			// NO HAY QUE USAR CURRENT LOD FACTOR SINO lodobj_container->lodobj_lodfactor
+				if (selnode->lodobj->GetCurrentLodFactor()>0.00001f)
+				{
+					if (selnode->to_update==0)
+						break;
+					else
+						selnode->to_update--;
+				}
+			}
+
+			if (selnode!=lodobj_container->lodobj_dists.Begin()-1)
+			{
+				// EL DECREMENTO O EL NUMERO DE DECREMENTOS TIENE QUE VENIR EN FUNCION DE LA DIFERENCIA DE FPS
+				// NO HAY QUE USAR CURRENT LOD FACTOR SINO lodobj_container->lodobj_lodfactor
+				selnode->lodobj->GoToLod(selnode->lodobj->GetCurrentLodFactor()-0.02f); 
+				selnode->to_update=10; // ESTO DEBE ASIGNARSE BASADO EN LA DISTANCIA A LA CAMARA!
+			}
+		}
+		if (currFPS > targetFPS + 5)
+		{
+			Vector<lodobj_node_t>::Iterator selnode;
+			for (selnode=lodobj_container->lodobj_dists.Begin(); selnode!=lodobj_container->lodobj_dists.End(); selnode++)
+			{			
+			// NO HAY QUE USAR CURRENT LOD FACTOR SINO lodobj_container->lodobj_lodfactor
+				if (selnode->lodobj->GetCurrentLodFactor()<0.99999f)
+				{
+					if (selnode->to_update==0)
+						break;
+					else
+						selnode->to_update--;
+				}
+			}
+
+			if (selnode!=lodobj_container->lodobj_dists.End())
+			{
+			// NO HAY QUE USAR CURRENT LOD FACTOR SINO lodobj_container->lodobj_lodfactor
+				selnode->lodobj->GoToLod(selnode->lodobj->GetCurrentLodFactor()+0.02f);
+				selnode->to_update=10; // ESTO DEBE ASIGNARSE BASADO EN LA DISTANCIA A LA CAMARA!
+			}
+		}*/
+
+		if (camera_changed)
+		{
+			// por ahora solo sacar el lod basado en la camara
+			for (Vector<lodobj_node_t>::Iterator it = lodobj_container->lodobj_dists.Begin(); 
+												 it != lodobj_container->lodobj_dists.End();  it ++)
+			{
+				float lodfactor = - ((it->dist2cam - near_range) / (far_range - near_range));
+				if (lodfactor < 0.0f)
+					lodfactor = 0.0f;
+				if (lodfactor > 1.0f)
+					lodfactor = 1.0f;
+
+				if (force_highest_lod)
+					lodfactor = 1.0f;
+
+				ChangeLOD(it,lodfactor);
+			}
+		}							   
 	}
 	camera_changed=false;
-}
-
-void Geometry::LodManager::RecalculateDist(lodobj_dist_node_t & node)
-{
-	std::map<uint32,Vector3>::iterator posit = lodobj_pos.find(node.lodobj->GetUniqueID());
-	assert(posit!=lodobj_pos.end());
-	const Vector3 & pos = posit->second;
-
-	node.dist2cam = CalculateDistToCamera(pos);
-}
-
+	node_added=false;
+}
+
+void Geometry::LodManager::ChangeLOD(lodobj_node_t *lodobjnode, Real lodfactor)
+{
+	LodObject *lodobj = lodobjnode->lodobj;
+
+	if (always_calculate_lod)
+	{
+		lodobj->GoToLod(lodfactor);
+		return;
+	}
+	
+	// if the lodfactor is exactly 1.0 its level of detail must be always regenerated (for closeups)
+	if (lodfactor<1.0f)
+	{
+		// if the desired lod is very similar to the previous one,
+		// then there is no need to change the level of detail at all
+//		float sim = fabsf(lodfactor - lodobjnode->lodfactor);
+//		if (sim <= MINIMUM_VALID_LOD_SIMILARITY)
+//			return; // do not change anything if the lod is very similar!
+		int desiredpos = lodobj_container->lod2precalpos(lodfactor);
+		int mypos = lodobj_container->lod2precalpos(lodobjnode->lodfactor);
+		if (mypos==desiredpos)
+			return;
+	}
+
+	lodobj_node_t *found_node = FindMostSimilarRealLOD(lodobjnode->name,lodfactor);
+
+	if (found_node && found_node->lodobj->GetUniqueID()!=lodobj->GetUniqueID())
+	{
+		// DEBUG
+		assert(found_node->master==NULL);
+
+//		float sim = fabsf(lodfactor - found_node->lodfactor);
+//		if (sim <= MINIMUM_VALID_LOD_SIMILARITY)
+		int desiredpos = lodobj_container->lod2precalpos(lodfactor);
+		int foundpos = lodobj_container->lod2precalpos(found_node->lodfactor);
+		if (foundpos==desiredpos)
+		{
+			lodobj->GetIndexDataInterface()->BorrowIndexData(found_node->lodobj->GetIndexDataInterface());
+			MakeDiscipleOf(found_node,lodobjnode);
+		}
+		else
+			ReallyGoToLOD(lodobjnode,lodfactor);
+	}
+	else
+		ReallyGoToLOD(lodobjnode,lodfactor);
+
+	lodobjnode->lodfactor = lodfactor;
+}
+
+void Geometry::LodManager::DeleteMeFromMyMastersDiscipleList(lodobj_node_t *lodobjnode)
+{
+	// if I have a master...
+	if (lodobjnode->master)
+		lodobjnode->master->disciples.RemoveKey(lodobjnode->lodobj->GetUniqueID());	
+}
+
+
+void Geometry::LodManager::MakeIndependent(lodobj_node_t *lodobjnode)
+{
+	DeleteMeFromMyMastersDiscipleList(lodobjnode);
+
+	// next, delete my master
+	lodobjnode->master=NULL;
+}
+
+void Geometry::LodManager::MakeDiscipleOf(lodobj_node_t *master_node, lodobj_node_t *disciple_node)
+{
+	ChangeMaster(disciple_node, master_node);
+
+	// delete my disciples
+	disciple_node->disciples.Clear();
+
+	// first remove me from my master's disciple list
+	DeleteMeFromMyMastersDiscipleList(disciple_node);
+
+	master_node->disciples.GetAdd(disciple_node->lodobj->GetUniqueID()) = disciple_node;
+
+	// set master
+	disciple_node->master = master_node;
+
+	// no one must take me as a master!
+	if (disciple_node->precalpos!=-1)
+	{		
+//		lodobj_container->precalculated_lods[disciple_node->precalpos] = NULL;
+		lodobj_container->GetPrecalculatedLOD(master_node->name,disciple_node->precalpos) = NULL;
+		disciple_node->precalpos = -1;
+	}
+}
+
+void Geometry::LodManager::ChangeMaster(lodobj_node_t *lodobj, lodobj_node_t *newmaster)
+{
+	// delete me from my disciples' master list
+	for (VectorMap<uint32,lodobj_node_t*>::Iterator it = lodobj->disciples.Begin(); it != lodobj->disciples.End(); it++)
+	{
+		lodobj_node_t * auxnode = *it;
+		assert(auxnode->master->lodobj->GetUniqueID() == lodobj->lodobj->GetUniqueID());
+//		auxnode->master = NULL;
+		// chanbge the master to the new one
+		auxnode->master = newmaster;
+
+		// add the new disciple to the new master
+		if (newmaster)
+			newmaster->disciples.GetAdd(auxnode->lodobj->GetUniqueID()) = auxnode;
+	}	
+}
+
+
+void Geometry::LodManager::UpdateDisciples(lodobj_node_t *master_node)
+{
+	for (VectorMap<uint32,lodobj_node_t*>::Iterator it= master_node->disciples.Begin(); it!= master_node->disciples.End(); it++)
+	{
+		lodobj_node_t *disciple_node = *it;
+		disciple_node->lodobj->GetIndexDataInterface()->BorrowIndexData(master_node->lodobj->GetIndexDataInterface());
+		disciple_node->lodfactor = master_node->lodobj->GetCurrentLodFactor(); // we can use currentlodfactor here because the master is supposed to be at its REAL level of detail
+	}
+}
+
+void Geometry::LodManager::ReallyGoToLOD(lodobj_node_t *lodobjnode, Real lodfactor)
+{
+	lodobjnode->lodobj->GoToLod(lodfactor);
+
+	MakeIndependent(lodobjnode);
+	UpdateDisciples(lodobjnode);
+
+	// store the precalculated lod in the table
+	int i = lodobj_container->lod2precalpos(lodfactor);
+
+	assert(i>=0 && i<=lodobj_container->num_lod_sim); // <= por lo del +1
+
+	if (lodobjnode->precalpos != -1)
+		//lodobj_container->precalculated_lods[lodobjnode->precalpos] = NULL;
+		lodobj_container->GetPrecalculatedLOD(lodobjnode->name,lodobjnode->precalpos) = NULL;
+
+//	lodobj_container->precalculated_lods[i] = lodobjnode;
+	lodobj_container->GetPrecalculatedLOD(lodobjnode->name,i) = lodobjnode;
+
+	lodobjnode->precalpos = i;
+}
+
+
+lodobj_node_t * Geometry::LodManager::FindMostSimilarRealLOD(const std::string &name, Real desired_lod)
+{
+	uint32 i = lodobj_container->lod2precalpos(desired_lod);
+	assert(i>=0 && i<=lodobj_container->num_lod_sim); // <= por lo del +1
+//	lodobj_node_t *obj = lodobj_container->precalculated_lods[i];
+	lodobj_node_t *obj = lodobj_container->GetPrecalculatedLOD(name,i);
+
+	return obj;
+}
 
 void Geometry::LodManager::UpdateCamera(const Geometry::Vector3 &p)
 {
-	camera_pos = p;
+	lodobj_container->camera_pos = p;
 	camera_changed = true;
 }
@@ -94,12 +388,7 @@
 void Geometry::LodManager::UpdateLODObjectPos(LodObject *o, const Geometry::Vector3 &p)
 {
-	lodobj_pos[o->GetUniqueID()] = p;
-}
-
-
-float Geometry::LodManager::CalculateDistToCamera(const Geometry::Vector3 &p) const
-{
-	return camera_pos.dotProduct(p);
-}
+	lodobj_container->lodobj_pos[o->GetUniqueID()] = p;
+}
+
 
 float Geometry::LodManager::SelectRandomDistance(void) const
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/leaves/foliage.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/leaves/foliage.cpp	(revision 1083)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/leaves/foliage.cpp	(revision 1526)
@@ -10,19 +10,27 @@
 // Parameters --> None
 //--------------------------------------------------------------------------------------------------------------------------------
-Foliage::Foliage(const Geometry::SubMesh *leavesSubMesh, const Geometry::TreeSimplificationSequence * simpSeq, Geometry::CREATEVERTEXDATAFUNC vdfun, Geometry::CREATEINDEXDATAFUNC idfun): 
+Foliage::Foliage(int leavessubmeshID, 
+				 const Geometry::SubMesh *leavesSubMesh, 
+				 const Geometry::TreeSimplificationSequence * simpSeq/*,
+				 Geometry::CREATEVERTEXDATAFUNC vdfun*/): 
 Acth(NULL),
-create_vertex_data_func(vdfun==NULL?Geometry::DefaultVertexDataCreator:vdfun),
-create_index_data_func(idfun==NULL?Geometry::DefaultIndexDataCreator:idfun),
-vertexdata(NULL), Leaves(NULL), MinDet(NULL)
+//create_vertex_data_func(vdfun==NULL?Geometry::DefaultVertexDataCreator:vdfun),
+//create_index_data_func(idfun==NULL?Geometry::DefaultIndexDataCreator:idfun),
+/*vertexdata(NULL),*/ Leaves(NULL), MinDet(NULL)
 {
 	begin = final = -1;
-
-	ReadVertices(leavesSubMesh);
+//	indexdata=NULL;
+
+//	ReadVertices(leavesSubMesh);
+	int countv= int(leavesSubMesh->mVertexBuffer->mVertexCount);
+	Leaves = new RuntimeLeaf[countv*2];
+	TotalVerts = countv;
+
 	ReadLeafs(leavesSubMesh);
 	if (!ReadSimpSeq(simpSeq)) exit(1);
 	FillRoot();
-	CalculateTexCoordsAndNorms();
-
-	indexdata->SetNumValidIndices(0);
+//	CalculateTexCoordsAndNorms();
+
+//	indexdata->SetNumValidIndices(0);
 
 	int h=0;
@@ -44,4 +52,5 @@
 	final = leafCount-1;
 	active_leaf_count = leafCount;
+	leavesSubMeshID=leavessubmeshID;
 }
 
@@ -51,6 +60,6 @@
 Foliage::~Foliage (void)
 {
-	if (vertexdata) delete vertexdata;
-	if (indexdata) delete indexdata;
+//	if (vertexdata) delete vertexdata;
+//	if (indexdata) delete indexdata;
 	delete[] Leaves;
 	delete MinDet;
@@ -222,5 +231,5 @@
 
  }
-
+/*
 void Foliage::ReadVertices(const Geometry::SubMesh *submesh)
 {
@@ -228,5 +237,5 @@
 	vertexdata = create_vertex_data_func(2*countv);
 	Leaves = new Leaf[countv*2];
-	indexdata = create_index_data_func(countv*2*3); // 3 indices x 2 triangulos x hoja
+	//indexdata = create_index_data_func(countv*2*3); // 3 indices x 2 triangulos x hoja
 	
 	vertexdata->Begin();
@@ -249,8 +258,4 @@
 	float twox, twoy, twoz;
 	float threex, threey, threez;
-
-/*	Vertices[aHoja.vertsLeaf[0]].GetCoordinates (onex, oney, onez);
-	Vertices[aHoja.vertsLeaf[1]].GetCoordinates(twox, twoy, twoz);
-	Vertices[aHoja.vertsLeaf[2]].GetCoordinates (threex, threey, threez);*/
 
 	vertexdata->GetVertexCoord(aleaf.vertsLeaf[0],onex,oney,onez);
@@ -286,5 +291,5 @@
 	res[2]=v[2]/module;
 }
-
+*/
 void Foliage::ReadLeafs(const Geometry::SubMesh *submesh)
 {
@@ -297,7 +302,7 @@
 		Leaves[h].vertsLeaf[2] = submesh->mIndex[h*6+2];
 		Leaves[h].vertsLeaf[3] = submesh->mIndex[h*6+5];
-		Leaves[h].visible = 0;
-
-		GetNormalH ( Leaves[h]);
+//		Leaves[h].visible = 0;
+
+//		GetNormalH ( Leaves[h]);
 	}
 }
@@ -316,7 +321,7 @@
 		Leaves[tn].vertsLeaf[3] = it->mNewQuad[3];
 
-		Leaves[tn].visible = 0;
-
-		GetNormalH  (Leaves[tn]);
+//		Leaves[tn].visible = 0;
+
+//		GetNormalH  (Leaves[tn]);
 
 		tv1 = it->mV0/2;
@@ -433,5 +438,5 @@
 }
 
-void Foliage::CalculateTexCoordsAndNorms(void)
+/*void Foliage::CalculateTexCoordsAndNorms(void)
 {	
 	vertexdata->Begin();
@@ -453,5 +458,5 @@
 	vertexdata->End();
 }
-
+*/
 Foliage::Foliage(const Foliage *ar)
 {
@@ -465,6 +470,6 @@
 	TotalVerts=ar->TotalVerts;
 
-	create_vertex_data_func=ar->create_vertex_data_func;
-	create_index_data_func=ar->create_index_data_func;
+/*	create_vertex_data_func=ar->create_vertex_data_func;
+//	create_index_data_func=ar->create_index_data_func;
 	vertexdata=create_vertex_data_func(ar->vertexdata->GetNumVertices());
 	vertexdata->Begin(); 
@@ -477,18 +482,18 @@
 		vertexdata->SetVertexNormal(i,va,vb,vc);
 	}
-	vertexdata->End();
-	indexdata=create_index_data_func(ar->indexdata->GetNumMaxIndices());
-	indexdata->Begin(); 
+	vertexdata->End();*/
+/*	indexdata=create_index_data_func(ar->indexdata->GetNumMaxIndices());
+	indexdata->Begin(ar->leavesSubMeshID,indexdata->GetNumMaxIndices());
 	for (unsigned int i=0; i<indexdata->GetNumMaxIndices(); i++) 
 		indexdata->SetIndex(i,ar->indexdata->GetIndex(i));
-	indexdata->End();
-
-	Leaves=new Leaf[vertexdata->GetNumVertices()];
+	indexdata->End();*/
+
+	Leaves=new RuntimeLeaf[TotalVerts];
 //	for (unsigned int i=0; i<vertexdata->GetNumVertices(); i++) 
 //		Leaves[i]=ar->Leaves[i];
-	memcpy(Leaves,ar->Leaves,sizeof(Leaf)*vertexdata->GetNumVertices());
+	memcpy(Leaves,ar->Leaves,sizeof(Leaf)*TotalVerts);
 
 	// esto no sé si devería haber akí
-	indexdata->SetNumValidIndices(0);
+//	indexdata->SetNumValidIndices(0);
 
 	int h=0;
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/leaves/Leaf.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/leaves/Leaf.cpp	(revision 1026)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/leaves/Leaf.cpp	(revision 1526)
@@ -10,5 +10,5 @@
 	vertsLeaf[0] = vertsLeaf[1] = vertsLeaf[2] = vertsLeaf[3] =0; 
 	center[0] = center[1] = center[2] = 0;
-	normal[0] = normal[1] = normal[2] = 0;
+//	normal[0] = normal[1] = normal[2] = 0;
 	leafNear=-1;
 	parentLeafCount = 1;
@@ -40,5 +40,5 @@
 	for ( int i=0;i<3;i++){
 		center[i] = aLeaf.center[i];
-		normal[i] = aLeaf.normal[i];
+//		normal[i] = aLeaf.normal[i];
 	}
 	for (i = 0L; i < 4; i++)
@@ -53,10 +53,21 @@
 
 
+RuntimeLeaf::RuntimeLeaf(void) 
+{	
+	vertsLeaf[0] = vertsLeaf[1] = vertsLeaf[2] = vertsLeaf[3] = 0;
+	parent = root = childLeft = childRight = -1;
+}
 
 //--------------------------------------------------------------------------------------------------------------------------------
-// Destructor. We must deallocate the memory allocated for pointers to vertices and edges
+// Copy constructor
 //--------------------------------------------------------------------------------------------------------------------------------
-Leaf::~Leaf (void)
+RuntimeLeaf::RuntimeLeaf (const RuntimeLeaf& aLeaf)
 {
+	for (int i = 0L; i < 4; i++)
+		vertsLeaf[i] = aLeaf.vertsLeaf[i]; 
+	parent = aLeaf.parent;
+	childLeft = aLeaf.childLeft;
+	childRight = aLeaf.childRight;
+	root = aLeaf.root;
 }
 
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/leaves/VertexData.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/leaves/VertexData.cpp	(revision 1105)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/leaves/VertexData.cpp	(revision 1526)
@@ -1,54 +1,19 @@
 #include "VertexData.h"
 
-Geometry::DefaultVertexData::DefaultVertexData(unsigned int numv):Geometry::VertexData(numv)
+/*
+void Geometry::DefaultIndexData::Init(unsigned int numi)
 {
-	v = new float[numv*3];
-	n = new float[numv*3];
-	t = new float[numv*2];
-}
-Geometry::DefaultVertexData::~DefaultVertexData(void)
-{
-/*	delete[] v;
-	delete[] n;
-	delete[] t;*/
-}
-
-Geometry::VertexData *Geometry::DefaultVertexDataCreator(unsigned int numv)
-{ 
-	return new DefaultVertexData(numv); 
-}
-
-
-Geometry::DefaultIndexData::DefaultIndexData(unsigned int numi):Geometry::IndexData(numi)
-{
-	indices = new unsigned int[numi];	
+	indices = new unsigned int[numi];
 }
 Geometry::DefaultIndexData::~DefaultIndexData(void)
 {
-/*	delete[] indices;*/
 }
 
 Geometry::IndexData *Geometry::DefaultIndexDataCreator(unsigned int numi)
 { 
-	return new DefaultIndexData(numi); 
+	IndexData *ret = new DefaultIndexData();
+//	ret->Init(numi);
+	return ret;
 }
 
-
-/*Geometry::DefaultMultiIndexData::DefaultMultiIndexData(unsigned int numprims, unsigned int *numi):Geometry::MultiIndexData(numprims,numi)
-{
-	indices = new unsigned int*[numprims];	
-	for (unsigned int i=0; i<numprims; i++)
-		indices[i]=new unsigned int[numi[i]];
-}
-Geometry::DefaultMultiIndexData::~DefaultMultiIndexData(void)
-{
-	for (unsigned int i=0; i<GetNumPrims(); i++)
-		delete[] indices[i];
-	delete[] indices;
-}
-
-Geometry::MultiIndexData *Geometry::DefaultMultiIndexDataCreator(unsigned int numprims, unsigned int *numi)
-{ 
-	return new DefaultMultiIndexData(numprims,numi); 
-}
 */
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/leaves/foliage.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/leaves/foliage.h	(revision 1083)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/leaves/foliage.h	(revision 1526)
@@ -26,6 +26,10 @@
 		int begin, final;
 		int active_leaf_count;
+		int leavesSubMeshID;
 
-		Foliage (const Geometry::SubMesh *, const Geometry::TreeSimplificationSequence *, Geometry::CREATEVERTEXDATAFUNC vdfun=NULL, Geometry::CREATEINDEXDATAFUNC idfun=NULL);
+		Foliage (	int leavesSubMeshID, 
+					const Geometry::SubMesh *, 
+					const Geometry::TreeSimplificationSequence *	);
+
 		Foliage (const Foliage *);
 		virtual ~Foliage (void); // Destructor
@@ -33,8 +37,5 @@
 		void CalculateLOD(int nhojas);
 
-		Geometry::VertexData *vertexdata;
-		Geometry::IndexData *indexdata;
-
-		Leaf   *Leaves;
+		RuntimeLeaf   *Leaves;
 		ActiveLeafNode  *MinDet; // first active leaf
 		int leafCount;
@@ -45,6 +46,4 @@
 
 	private:
-		Geometry::CREATEVERTEXDATAFUNC create_vertex_data_func;		
-		Geometry::CREATEINDEXDATAFUNC create_index_data_func;
 
 		bool IsActive( int num) const;
@@ -59,12 +58,4 @@
 		bool ReadSimpSeq(const Geometry::TreeSimplificationSequence *); /// returns true when successful
 		void FillRoot(void);
-
-		void GetNormalH (Leaf&);
-
-		void CrossProduct(const float *v1, const float *v2, float *res);
-		void Normalize(const float *v, float *res);
-//		void CalculaNormalesVertice(void);
-		void CalculateTexCoordsAndNorms(void);
-
 };
 
